﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Reflection;
using System.Xml;
using System.Xml.Linq;
using System.Dynamic;

namespace Expr
{
    class Program
    {
        static void Main(string[] args)
        {
            // get data file path
            string dataPath = MapPath("SampleData.xml");

            // read into stream
            using(StreamReader reader = new StreamReader(dataPath))
            {
                // load into XElement
                XElement doc = XElement.Load(reader);

                // using our ToDynamicList (Extenion Method)
                var people = doc.ToDynamicList();

                // loop through each person
                foreach(dynamic person in people)
                {
                    Console.WriteLine("id:\t" + person.Id);
                    Console.WriteLine("Name:\t" + person.Name);
                    Console.WriteLine("Age:\t" + person.Age);
                    Console.WriteLine("----------------------------------");
                    try
                    {
                        // loop through children, if any
                        foreach(dynamic child in person.Children)
                        {
                            Console.WriteLine("\tid:\t" + child.Id);
                            Console.WriteLine("\tName:\t" + child.Name);
                            Console.WriteLine("\tAge:\t" + child.Age);
                        }
                        Console.WriteLine("----------------------------------");
                    }
                    catch(Exception ex)
                    {
                    }
                }

            }

            // end...
            Console.WriteLine("Press any key to exit");
            Console.ReadKey();
        }

        // Maps a path from the execution folder
        static string MapPath(string path)
        {
            return Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), path);
        }
    }
}
